# readerWriter


from threading import *
import random, time

class Repository:
    def __init__(self):
        #don't use agents in your solution
        self.agents = []
        

    def enter(self, agentType):
        self.agents.append(agentType)
        print (self.agents)

    def leave(self, agentType):
        self.agents.remove(agentType)
        print (self.agents)

def reader(repo):
    repo.enter('reader')
    time.sleep(random.random() / 2)
    repo.leave('reader')

def writer(repo):
    repo.enter('writer')
    time.sleep(random.random() / 2)
    repo.leave('writer')

def loop(repo, f, mu=1):
    x = 0
    while x < 10:
        t = random.expovariate(1.0/mu)
        time.sleep(t)
        f(repo)
        x += 1

repo = Repository()
fs =  [reader] * 5 + [writer]*3 
threads = [Thread(target=loop, args=(repo, f)) for f in fs]
for thread in threads: thread.start()
for thread in threads: thread.join()

